function add_functions_in(source,target,tag)
---
-- adds the functions in table "source" to table "target" with given tag
-- returns a list of all tables in "source"
   local t={}
   for k,v in pairs(source) do
      if type(v)=='function' then target[tag..'.'..k]=v
      elseif type(v)=='table' then t[k]=v
      end
   end
   return t
end

local done = {}
function catalog(source,target,tag)
-- recursively adds the functions in table "source" and all functions
-- accessible via "source" to table "target"
   local new=add_functions_in(source,target,tag)
   done[source]=true
   for k,v in pairs(new) do if not done[v] then
      done[v]=true
      catalog(v,target,tag.."."..k)
   end end
   return target
end

function love.load()
lr = love.run --save the default love.run callback as lr
end

function love.run()
math.randomseed(os.time())
math.random() math.random()
if love.load then love.load(arg) end
local dt = 0
-- Main loop time.
while true do
-- Process events.
if love.event then
love.event.pump()
for e,a,b,c,d in love.event.poll() do
if e == "quit" then
if not love.quit or not love.quit() then
if love.audio then
love.audio.stop()
end
return
end
end
love.handlers[e](a,b,c,d)
end
end
-- Update dt, as we'll be passing it to update
if love.timer then
love.timer.step()
dt = love.timer.getDelta()
end

if love.update then love.update(dt) end -- will pass 0 if is disabled
if love.graphics then
love.graphics.clear()
if love.draw then love.draw() end
end
if love.timer then love.timer.sleep(0.001) end
if love.graphics then love.graphics.present() end
end
end

function love.quit()  
  --are you sure???
end

function splash()
  love.event.quit()
end

function love.quit()
  love.graphics.clear()
  for x=150,255,5 do for y=150,255,5 do for z=150,255,5 do
  love.graphics.setColor(x,y,z)
  love.graphics.print("Nooo0!! Why are you terminating me?? DON'T QuIT!!??",200,200)
  end
love.graphics.present()
end
end
  love.timer.sleep(3)
end

notdrawn = 1
function love.update()
if notdrawn == 1 then 
lr = love.run
love.run = splash()
cat=catalog(_G,{},"_G")
i=0
j=0
ic=0
jc=0
love.graphics.setColor(200+i,100-i,200+i)
notdrawn = 0
--love.timer = nil
end
--love.run = lr
end

function love.draw()
i= i % 255
ic= ic % 255
la = 1
for k,v in pairs(cat) do for la= 1,#k,la+1 do j= j % 255 jc= jc % 255 love.graphics.setColor(90+j,90+ic%255,100+jc)  love.graphics.print(string.sub(k, la, la+1),20+j*4+la*4,i) jc= jc +5 ic = ((ic + 10) % 255 )end  i = ((i + 10) % love.graphics.getHeight()) j=j+5 love.graphics.present() end  
end
